//=============================================================================
//
//
//
//
//
//=============================================================================
#ifndef		__R7_LAUNCHPAD_H
#define		__R7_LAUNCHPAD_H

class DLLEXPORT R7_second_stage: public VESSEL2
{
public:
	void StartLaunchProg(void);
	void SetHyroplatform(double, double);
	bool LaunchpadFree(void);
	void SetTaget(double, double);
	void SetVground(double);
	double GetFirstStageLevel(void);
	void SetOrbitParams(double Ha, double Hp, double inc);
	void SetLaunchParams(double psi0, double omega0, double Vk);
	double GetPayLoadMass(void);
	int GetConfig(void);
};

class DLLEXPORT R7_launchpad: public VESSEL2
{
public:
	R7_launchpad(OBJHANDLE, int);
	~R7_launchpad(){};

	void clbkSetClassCaps(FILEHANDLE);
	void clbkLoadStateEx(FILEHANDLE scn, void *status);
	void clbkSaveState(FILEHANDLE scn);
	void clbkPostStep(double, double, double);
	void clbkVisualCreated(VISHANDLE, int);
	void clbkVisualDestroyed(VISHANDLE, int);
	int clbkConsumeDirectKey(char *);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);

	double PhiT, LambdaT;
	void StartLaunchOperations(void);

private:
	OBJHANDLE				hR7Obj;
	OBJHANDLE				hLauncher;
	MESHHANDLE				hFerma01;
	MESHHANDLE				hFerma02;
	MESHHANDLE				hFerma03;
	MESHHANDLE				hLaunchpad;
	MESHGROUP_TRANSFORM		mt0, mt1, mt2, mt3, mt4, mt5, mt6;
	VISHANDLE				vis;
	ATTACHMENTHANDLE		hR7Att;
	PARTICLESTREAMSPEC		psc, psc1;
	SURFHANDLE				ptex;
	VESSEL					*R7;
	R7_second_stage			*hR7;	

	float			A,  OmegaA;
	float			Beta, OmegaBeta;
	float			Psi, OmegaPsi;
	float			SAngleMax;
	float			FreeTime;

	int			Ready01, Ready02, Ready03, Ready04, Start, CalcLock, CalcStart, FirstStep, begin;

	int				LaunchState;
	int				Far;
	int				Natt;
	int				config;
	int				LauncherType;
	int				locksad;

	float			STime, Time;
	double			psi0, omega0, Vk0;
	float			AL;
	double			h0;
	double			plevel;
	double			StartMJD;

	bool			StartAtDate;

	char			LauncherName[255];
	
	float			IncScn;


	void AzimutRotation(double, double);
	double GetLaunchAzimut(double, double);
	void Ferms01LoadRotation(void);
	void ServiceFermsRotation(double, double);
	void LaunchFermsRotation(double , double);
	void BeginStart(void);
};

#endif